<?php

/* CONFIG ----------------------------------------------------------------------------------------------------------- */
$browser_cache 	= 604800;				// browser cache time in seconds
$cache_folder 	= "/cache/css/";		// cache-folder relative to $_SERVER["DOCUMENT_ROOT"]
$cache_ext  	= '.mincss'; 			// cache-filename (anything ending on ".css" doesn't work)

/* END CONFIG ----------------------------------------------------------------------------------------------------------
------------------------ Don't edit anything after this line unless you know what you're doing -------------------------
--------------------------------------------------------------------------------------------------------------------- */

// absolute server-path to css file
$serverpath_org = $_SERVER["DOCUMENT_ROOT"].str_replace($_SERVER['PHP_SELF'],"",str_replace($_SERVER["DOCUMENT_ROOT"], "", __FILE__)).preg_replace("/\?.+/","",($_SERVER['REQUEST_URI']));

if (!(file_exists($serverpath_org))) {header("HTTP/1.0 404 Not Found");exit();}	// original-Datei existiert nicht --> 404

// absolute server-path to cache-file
$serverpath_cache = $_SERVER["DOCUMENT_ROOT"].rtrim($cache_folder, '/').'/'.preg_replace("/\?.+/","",$_SERVER['REQUEST_URI']).$cache_ext;


function readf($filepath){return file_get_contents($filepath);}	//read & return given file
function writef($filepath, $content){	// write given content to file
	if(!file_exists(dirname($filepath))){mkdir(dirname($filepath), 0775, true);}	// create folder for file if not exist
	//$handle = fopen($filepath,"w");fwrite($handle, $content);fclose($handle);		// write file
	file_put_contents($filepath, $content);		// write file
}

function cached(){ // check if user already has the correct cache file 
	global $browser_cache;
	if(isset($_SERVER['HTTP_IF_MODIFIED_SINCE'])) {
		if(strtotime($_SERVER['HTTP_IF_MODIFIED_SINCE']) <= time()) {
			header('HTTP/1.1 304 Not Modified');
			header("Cache-Control: public, max-age".$browser_cache);
			exit();
}}}
function send($filepath){	// send given file to user
	global $browser_cache;
	header("HTTP/1.1 200 OK", true);
	header("Content-Type: text/css");
	header("Cache-Control: public, max-age=".$browser_cache);
	header('Last-Modified: '.gmdate('D, d M Y H:i:s', date(filemtime($filepath))).' GMT');
	header('X-Powered-By:PHP/'.phpversion());
	//header('Expires: '.gmdate('D, d M Y H:i:s', (time()+$browser_cache)).' GMT');
	
	ob_start("ob_gzhandler");	// Enable GZip encoding.
	echo readf($filepath);		// Write everything out
	ob_end_flush();				// End of GZip encoding.
}

function minimize($rawcss){	// minimize given css code
	// remove unnecessary characters
	$buffer = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $rawcss);	// Remove comments	
	$buffer = str_replace(array("\r\n", "\r", "\n", "\t"), '', $buffer);	// Remove space after colons
	$buffer = preg_replace('/ {2,}/', ' ', 	$buffer);		// Collapse adjacent spaces into a single space
	$buffer = str_replace(	' @', 	'@', 	$buffer);		// Remove spaces that might still be left where we know they aren't needed
	$buffer = str_replace(	': ', 	':', 	$buffer);
	$buffer = str_replace(	'{ ', 	'{', 	$buffer);
	$buffer = str_replace(	' {', 	'{', 	$buffer);
	$buffer = str_replace(	'} ', 	'}', 	$buffer);
	$buffer = str_replace(	' }', 	'}', 	$buffer);
	$buffer = str_replace(	'; ', 	';', 	$buffer);
	$buffer = str_replace(	' ;', 	';', 	$buffer);
	$buffer = str_replace(	', ', 	', ', 	$buffer);			
	$buffer = str_replace(	' ,', 	' ,', 	$buffer);
	$buffer = str_replace(	';}',  	'}', 	$buffer);
	// return minimized css
	return $buffer;
}
writef("test.txt", "test...");
// Start the magic...
if (file_exists($serverpath_cache) && (filemtime($serverpath_org) < filemtime($serverpath_cache))	) {	// cache isn't overaged, so send it to user
	cached(); send($serverpath_cache); }
else {	// the cached file doesn't exist or is very old, so we need to generate a new one and send it to the user
	writef($serverpath_cache, minimize(readf($serverpath_org)));
	send($serverpath_cache);	
}
?>